---
title: FileSystemDirectoryHandle
slug: Web/API/FileSystemDirectoryHandle
tags:
  - Directories
  - Directory
  - File System Access API
  - FileSystemDirectoryHandle
  - Files
  - Interface
  - working with directories
---
<div>{{draft}}{{securecontext_header}}{{DefaultAPISidebar("File System Access API")}}</div>

<p class="summary">The <strong><code>FileSystemDirectoryHandle</code></strong> interface of the {{domxref('File System Access API')}} provides a handle to a file system directory. The interface is accessed via the {{domxref('window.showDirectoryPicker()')}} method.</p>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent, {{DOMxRef("FileSystemHandle")}}.</em></p>

<h2 id="Methods">Methods</h2>

<p><em>Inherits methods from its parent, {{DOMxRef("FileSystemHandle")}}.</em></p>

<dl>
 <dt>{{domxref('FileSystemDirectoryHandle.entries()')}}</dt>
 <dd>Returns an {{jsxref('Array')}} of a given object's own enumerable property <code>[key, value]</code> pairs</dd>
 <dt>{{domxref('FileSystemDirectoryHandle.getFileHandle()')}}</dt>
 <dd>Returns a {{domxref('FileSystemFileHandle')}} for a file with the specified name, within the directory the method is called.</dd>
 <dt>{{domxref('FileSystemDirectoryHandle.getDirectoryHandle()')}}</dt>
 <dd>Returns a {{domxref('FileSystemDirectoryHandle')}} for a subdirectory with the specified name within the directory handle on which the method is called.</dd>
 <dt>{{domxref('FileSystemDirectoryHandle.keys()')}}</dt>
 <dd>Returns a new Array Iterator containing the keys for each item in <code>FileSystemDirectoryHandle</code>.</dd>
 <dt>{{domxref('FileSystemDirectoryHandle.removeEntry()')}}</dt>
 <dd>Attempts to remove an entry if the directory handle contains a file or directory called the name specified.</dd>
 <dt>{{domxref('FileSystemDirectoryHandle.resolve()')}}</dt>
 <dd>Returns an {{jsxref('Array')}} of directory names from the parent handle to the specified child entry, with the name of the child entry as the last array item.</dd>
 <dt>{{domxref('FileSystemDirectoryHandle.values()')}}</dt>
 <dd>Returns a new Array Iterator containing the values for each index in the <code>FileSystemDirectoryHandle</code> object.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following example returns a directory handle with the specified name, if the directory does not exist it is created.</p>

<pre class="brush: js notranslate">const dirName = 'directoryToGetName';

// assuming we have a directory handle: 'currentDirHandle'
const subDir = currentDirHandle.getDirectoryHandle(dirName, {create: true});</pre>

<p>The following asynchronous function uses <code>resolve()</code> to find the path to a chosen file, relative to a specified directory handle.</p>

<pre class="brush: js notranslate">async function returnPathDirectories(directoryHandle) {

  // Get a file handle by showing a file picker:
  const handle = await self.showOpenFilePicker();
  if (!handle) {
    // User cancelled, or otherwise failed to open a file.
    return;
  }

  // Check if handle exists inside directory our directory handle
  const relativePaths = await directoryHandle.resolve(handle);

  if (relativePath === null) {
    // Not inside directory handle
  } else {
    // relativePath is an array of names, giving the relative path

    for (const name of relativePaths) {
      // log each entry
      console.log(name);
    }
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('File System Access API','#api-filesystemdirectoryhandle','FileSystemDirectoryHandle')}}</td>
   <td>{{Spec2('File System Access API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemDirectoryHandle")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/docs/Web/API/File_System_Access_API">File System Access API</a></li>
 <li><a href="https://web.dev/file-system-access/">The File System Access API: simplifying access to local files</a></li>
</ul>
